#!/bin/sh
##-------------------------------------------------------------------------------
## OUMA is Copyright (c)  2003 Volker Krause <volker_krause@gmx.net>
##
## Creation:     02.04.2003  mm
## Last Update:  02.04.2003  mm
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation in Version 2; Not any previous or future
## version.
##-------------------------------------------------------------------------------

SEC_REALM='ouma'
SEC_ACTION='manage'

. sec-lib.cgi 	

/sbin/ipchains -M -L -n > /tmp/ouma/internet1
hostname=`cat /tmp/ouma/hn`
param_show="nix"
param_all="nix"
for var in `echo "$QUERY_STRING" | tr '&' ' '`
do
 if echo "$var" | grep -v "=" > /dev/null ; then var="$var=yes" ; fi
 eval "param_$var"
done

if test $param_all = "unblock"
then
	set `cat /tmp/ouma/hosts`
	ip_count=$#

	count=1
	while [ $count -le $ip_count ]
	do
		help1="\$1"
		ip=`eval "echo $help1"`
		export ip
		/bin/ouma_unblockip.sh
		count=`/usr/bin/expr $count + 2`
		shift 2
	done
fi
if test $param_all = "block"
then
	set `cat /tmp/ouma/hosts`
	ip_count=$#

	count=1
	while [ $count -le $ip_count ]
	do
		help1="\$1"
		ip=`eval "echo $help1"`
		export ip
		/bin/ouma_blockip.sh
		count=`/usr/bin/expr $count + 2`
		shift 2
	done
fi

b="ouma_blockip.cgi"
t="<a href=\"ouma_begincount.cgi"

echo "Content-Type: text/html; charset=iso-8859-15"
echo "Cache-control: no-store"
echo "Pragma: no-cache"
echo "Expires: `date -Ru`"
echo ""
echo "
<html>
 <meta HTTP-EQUIV=\"Refresh\" CONTENT=\"70;url=main_User-Manager.cgi\">
 <head>
  <title>OUMA Liste</title>
 </head>
 <body bgcolor=ffffff link=0000aa vlink=0000aa>
   Hostliste: 
  <br>"
echo "<center><table><colgroup><col width=100><col width=100><col width=50><col width=50><col width=100><col width=40><col width=40><col width=40><col width=40></colgroup><tr><td>IP:</td><td>Hostname:</td><td>Status:</td><td>Internet:</td><td>Internetstatus:</td><td>Zeit</td><td>Zeit</td><td>Zeit</td><td>Zeit</td></tr>"

set `cat /tmp/ouma/hosts`
ip_count=$#

count=1
while [ $count -le $ip_count ]
do
	help1="\$1"
	help2="\$2"
	ip=`eval "echo $help1"`
	hn=`eval "echo $help2"`
	if test -f /tmp/ouma/nofping
	then
		status="<font color=#2020aa>unbekannt</font>"
	else
		if test ! -f /tmp/ouma/$ip.online
		then 
			status="<font color=#aa2020>aus</font>"
		else 
			status="<font color=#20aa20>an</font>"
		fi
	fi
            if grep $ip /tmp/ouma/internet1 >/dev/null;
	
		then 
			istatus="<font color=#20aa20>an</font>"
		else 
			istatus="<font color=#aa2020>aus</font>"
	fi
	if test -f /tmp/ouma/$ip.time
	then
		timeleft=`cat /tmp/ouma/$ip.time`
		block="<a href=\"$b?ip=$ip&action=block\">
		<font color=#00bb00>$timeleft Min.</font></a>"
	elif test -f /tmp/ouma/$ip.blocked
	then 
		block="<a href=\"$b?ip=$ip&action=unblock\">
		<font color=#bb0000>nein</font></a>"
	else 
		block="<a href=\"$b?ip=$ip&action=block\">
		<font color=#00bb00>ja</font></a>"
	fi	
		echo "
		<tr>
			<td>$ip</td>
			<td>$hn</td>
			<td>$status</td>
			<td>$istatus</td>
			<td>$block</td>
			<td>$t?time=30&ip=$ip\">30min</a></td>
			<td>$t?time=60&ip=$ip\">1h</a></td>
			<td>$t?time=120&ip=$ip\">2h</a></td>
			<td>$t?time=240&ip=$ip\">4h</a></td>
		</tr>"
	count=`/usr/bin/expr $count + 2`
	shift 2
done
rm -f /tmp/ouma/internet1
echo "</table></center>
"
echo "<br>"
if test ! -f /tmp/ouma/nofping
then
	echo "<a href='ouma_updatehosts.cgi'>Hier</a> klicken, um den Rechnerstatus zu aktualisieren."
fi
echo "<br><a href='main_User-Manager.cgi?all=unblock'>Hier</a> klicken, wenn alle Hosts freigeschaltet werden sollen.<br>
          <a href='main_User-Manager.cgi?all=block'>Hier</a> klicken, wenn alle Hosts gesperrt werden sollen.<br></body></html>"



