#!/bin/sh

##-------------------------------------------------------------------------------
## OUMA is Copyright (c)  2003 Volker Krause <volker_krause@gmx.net>
##
## Creation:     02.04.2003  mm
## Last Update:  02.04.2003  mm
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation in Version 2; Not any previous or future
## version.
##-------------------------------------------------------------------------------

if test -f /tmp/ouma/$ip.blocked
then
	rm -f /tmp/ouma/$ip.time
else
	if test -f /tmp/ouma/$ip.neverblock
	then
		;
	else
		hostname=`cat /tmp/ouma/hn`
		/sbin/ipchains -I input 1 -p tcp -s $ip -d ! $hostname -j DENY
		if test -f /tmp/ouma/blockudp
		then
			/sbin/ipchains -I input 1 -p udp -s $ip -d ! $hostname -j DENY
		fi
		if test -f /tmp/ouma/blockicmp
		then
			/sbin/ipchains -I input 1 -p icmp -s $ip -d ! $hostname -j DENY
		fi
		echo "" > /tmp/ouma/$ip.blocked
		rm -f /tmp/ouma/$ip.time
	fi
fi